VisualEditor: Improvements to reference editing, including local wiki-specific workflows
Closed, ResolvedPublic



There are, I think, some UI improvements to be made to the reference editor - User:Popcornduff gets credit for these :).

When you first open the reference editor, you're presented with something like screenshot 1, which asks you "What do you want to reference?" If the user is coming to try and add a new reference, this is highly confusing - the first UI element they're presented with prompts them to put time into a series of actions that cannot possibly end with them finding what they want. The cue also doesn't make clear to any user what the search bar is actually doing - filtering existing references. It seems like the blurb here might need changing to align it with what the search bar actually does; "search existing references on this page"?

If you click "create new source", absolutely nothing happens - it's a highlightable element, and after a bit you can puzzle out that it unlocks "create reference", but it's not immediately clear. Still, you end up with it highlighted (see screenshot2). The blurb in "insert reference" is rather confusing; what am I inserting? I'm here to /add/ a new reference, I haven't written it out yet. My suggestion would be to have "create new source" take you straight to the source creation interface using a one-click mechanism, rather than having it free up "insert no references".

Still, you click it, and you get to screenshot3, of a window tagged "reference content". Quoth the user, "Is it reference the verb - am I referencing content here? Or am I giving content to the reference?

What is the Options heading all about, and what does "Use this group" mean?

I have a little window here to type into. I'm not sure what to type. Do I just write out my reference in Wikimarkup and click "Apply changes"? Or do I write them out as if I'm writing a list of references at the end of an essay?

At this point I'm really disappointed. I was hoping to be given a complete list of individual fields to fill out - a box for author, a box for date, a box for date accessed, a box for the title, a box for the URL, and so on - and have this generate the reference nicely for me. Instead, I seem to have the old system in a confusing UI."

Version: unspecified
Severity: enhancement
See Also:


bzimport set Reference to bz50458.
Ironholds created this task.Via LegacyJun 30 2013, 12:50 PM
Ironholds added a comment.Via ConduitJun 30 2013, 12:51 PM



Ironholds added a comment.Via ConduitJun 30 2013, 12:51 PM



PamD added a comment.Via ConduitJul 1 2013, 3:04 PM

Please look at how RefToolbar behaves (I choose whether my ref is a website, book, etc; I get offered a set of useful boxes into which to input the data; I click on "Preview citation" to see that it looks OK; I click on "Add citation". Job done.), and give this sort of useful guidance to editors adding references in VE.

Jdforrester-WMF added a comment.Via ConduitJul 1 2013, 3:10 PM

Thanks for these comments; obviously the references system is a work in progress and we had already planned to undertake (at least most of) these improvements, but we hadn't had the time to write it down in bugzilla - will use this to track those improvements now.

bzimport added a comment.Via ConduitJul 2 2013, 1:21 AM

gwaw_2003 wrote:

I'd have to agree with PamD above. If anything, just steal the RefToolbar code, and make it work with VE as a temporary fix for enwp. This cannot be rolled out to new editors the way it is, or we'll have a ton of "well I hated how the references worked so I stopped trying to use them at all" edits from new editors.

DougWeller added a comment.Via ConduitJul 2 2013, 10:37 AM

dougweller wrote:

Please don't roll this out to everyone until this is fixed, as until it is there is going to be a lot of cleanup work needed. I agree with those above who say this might mean less references. I quickly disabled it the first time I tried to create a new citation.

Mattflaschen added a comment.Via ConduitJul 3 2013, 5:34 AM

Yes, I think the "wiki-specific workflows" is key. On wikis (including English Wikipedia) that use:

<ref>{{some template|firstparam=a}}</ref>

with a few key some templates, it's worth allowing a simplified flow for those (while still providing the full flexibility of arbitrary references and arbitrary templates where needed).

Within a template, it's also verbose due to the screen layout. E.g. I would consider keeping parameter name and value on the same screen (for named parameters), and making it easy to add the next parameter without going up to the root. The latter can be done without the former.

I'd recommend trying ProveIt ( on English Wikipedia if you haven't. I don't expect you to take the same approach we did (and don't look at the "parser"). The reference browsing part also probably doesn't apply, but the add mode in particular shows how the GUI can be streamlined when it doesn't attempt to be fully general.

Ironholds added a comment.Via ConduitJul 3 2013, 1:39 PM

The "what do you want to reference?" field, which exists solely to filter through existing references, still displays if there are zero existing references.

gerritbot added a comment.Via ConduitJul 18 2013, 9:14 PM

Change 74191 had a related patch set uploaded by Jforrester:
Reference dialog commingling

gerritbot added a comment.Via ConduitJul 18 2013, 9:39 PM

Change 74191 merged by jenkins-bot:
Reference dialog commingling

Thryduulf added a comment.Via ConduitAug 27 2013, 10:02 AM

At en.wp user:Risker reports on feedback she received running an editathon. Relevant to this bug is:

To a person, they all said that VE was *more* difficult to use than wikitext, especially with respect to references. Now, they had all had reinforced to them the importance of referencing factual information, so they were all trying to include references. They pointed out that at least with the wikitext editor, they could pull up templates that were complete and they didn't have to try to figure out the parameters. They were using mostly printed sources, not websites, so there was no URL to use as a quick-and-dirty reference insertion.

Thryduulf added a comment.Via ConduitAug 27 2013, 10:04 AM

(In reply to comment #8)

The "what do you want to reference?" field, which exists solely to filter
through existing references, still displays if there are zero existing

This sounds like bug 51848

Jdforrester-WMF added a comment.Via ConduitAug 30 2013, 2:50 AM
  • Bug 51184 has been marked as a duplicate of this bug. ***
Jdforrester-WMF added a comment.Via ConduitMay 30 2014, 5:52 PM

This was resolved with the new citation system released last month.

Mattflaschen removed a subscriber: Mattflaschen.Via WebDec 3 2014, 5:27 AM

Add Comment